unit inputs;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, engine;

type
  TinputsForm = class(TForm)
    inputGrid: TStringGrid;
    acceptButton: TButton;
    GraphOutBtn: TButton;
    procedure FormCreate(Sender: TObject);
    procedure acceptButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure GraphOutBtnClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  inputsForm: TinputsForm;

implementation

uses draw;

{$R *.DFM}

procedure TinputsForm.FormCreate(Sender: TObject);
begin
  { text entry }
  inputGrid.defaultColWidth:= (inputGrid.Width div 2)-2;
  inputGrid.editorMode:= true;
  inputGrid.Cells[0,0]:= 'INPUTS:(please see HELP.TXT)';
  inputGrid.Cells[0,1]:= 'emitter diameter [mm]';
  inputGrid.Cells[0,2]:= 'accelerator diameter [mm]';
  inputGrid.Cells[0,3]:= 'collectors start diameter [mm]';
  inputGrid.Cells[0,4]:= 'collectors end diameter [mm]';
  inputGrid.Cells[0,5]:= 'collectors/deflectors count [pcs]';
  inputGrid.Cells[0,6]:= 'acceleration voltage [V]';
  inputGrid.Cells[0,7]:= 'deflection voltage [V]';
  inputGrid.Cells[0,8]:= '--------';
  inputGrid.Cells[0,9]:= 'time step (ds=v*dt) [ns]';
  inputGrid.Cells[0,10]:= '# of emmited electrons';
  inputGrid.Cells[0,11]:= 'emission energy [eV]';
  inputGrid.Cells[0,12]:= 'sensitivity [mm]';

  inputGrid.Cells[1,1]:= '25';
  inputGrid.Cells[1,2]:= '50';
  inputGrid.Cells[1,3]:= '27';
  inputGrid.Cells[1,4]:= '48';
  inputGrid.Cells[1,5]:= '10';
  inputGrid.Cells[1,6]:= '5';
  inputGrid.Cells[1,7]:= '5';
  inputGrid.Cells[1,8]:= '---------';
  inputGrid.Cells[1,9]:= '0,08';
  inputGrid.Cells[1,10]:= '100';
  inputGrid.Cells[1,11]:= '0,5';
  inputGrid.Cells[1,12]:= '0,01';
end;

procedure TinputsForm.acceptButtonClick(Sender: TObject);
begin
  emitterDia:= strToFloat(inputGrid.Cells[1,1])/1000;
  acclrDia:= strToFloat(inputGrid.Cells[1,2])/1000;
  startCDia:= strToFloat(inputGrid.Cells[1,3])/1000;
  endCDia:= strToFloat(inputGrid.Cells[1,4])/1000;
  coldefCount:= strToInt(inputGrid.Cells[1,5]);
  acclrV:= strToFloat(inputGrid.Cells[1,6]);
  deflectV:= strToFloat(inputGrid.Cells[1,7]);
  ts:=strToFloat(inputGrid.Cells[1,9])/1E+9;
  emittedEl:=strToInt(inputGrid.Cells[1,10]);
  emissionEnergy:= strToFloat(inputGrid.Cells[1,11]);
  sens:= strToFloat(inputGrid.Cells[1,12]);
  setEmissionVelo;
  drawForm.refresh;
  drawForm.FormPaint(self);
end;

procedure TinputsForm.FormShow(Sender: TObject);
begin
  drawForm.show;
end;

procedure TinputsForm.GraphOutBtnClick(Sender: TObject);
begin
  drawForm.show;
end;

procedure TinputsForm.FormResize(Sender: TObject);
begin
  acceptButton.left:= inputsForm.width-120;
  acceptButton.top:= inputsForm.height-90;
  graphOutBtn.left:= inputsForm.width-120;
  graphOutBtn.top:= inputsForm.height-60;
  inputGrid.defaultColWidth:= (inputGrid.Width div 2)-2;
end;

end.
